EOAPI const Eo_Event_Description _EFL_FILE_EVENT_ASYNC_OPENED =
   EO_EVENT_DESCRIPTION("async,opened", "The file was successfully opened asynchronously");
EOAPI const Eo_Event_Description _EFL_FILE_EVENT_ASYNC_ERROR =
   EO_EVENT_DESCRIPTION("async,error", "Error occured in asynchronous file operation");
EOAPI EO_FUNC_BODYV(efl_file_mmap_set, Eina_Bool, 0, EO_FUNC_CALL(f, key), const Eina_File *f, const char *key);
EOAPI EO_VOID_FUNC_BODYV(efl_file_mmap_get, EO_FUNC_CALL(f, key), const Eina_File **f, const char **key);
EOAPI EO_FUNC_BODYV(efl_file_set, Eina_Bool, 0, EO_FUNC_CALL(file, key), const char *file, const char *key);
EOAPI EO_VOID_FUNC_BODYV(efl_file_get, EO_FUNC_CALL(file, key), const char **file, const char **key);
EOAPI EO_VOID_FUNC_BODYV(efl_file_async_set, EO_FUNC_CALL(async), Eina_Bool async);
EOAPI EO_FUNC_BODY(efl_file_async_get, Eina_Bool, 0);
EOAPI EO_FUNC_BODYV(efl_file_save, Eina_Bool, 0, EO_FUNC_CALL(file, key, flags), const char *file, const char *key, const char *flags);
EOAPI EO_VOID_FUNC_BODY(efl_file_eject);
EOAPI EO_FUNC_BODY(efl_file_async_wait, Eina_Bool, 0);

static Eo_Op_Description _efl_file_op_desc[] = {
     EO_OP_FUNC(efl_file_mmap_set, NULL, "Set the source mmaped file from where an image object must fetch the real image data (it must be an Eina_File)."),
     EO_OP_FUNC(efl_file_mmap_get, NULL, "Get the source mmaped file from where an image object must fetch the real image data (it must be an Eina_File)."),
     EO_OP_FUNC(efl_file_set, NULL, "Set the source file from where an image object must fetch the real image data (it may be an Eet file, besides pure image ones)."),
     EO_OP_FUNC(efl_file_get, NULL, "Retrieve the source file from where an image object is to fetch the real image data (it may be an Eet file, besides pure image ones)."),
     EO_OP_FUNC(efl_file_async_set, NULL, "If true, file open will happen asynchronously allowing for better performance in some situations. The file will be opened from a different thread. Classes implementing async open might then block and wait when querying information from the file (eg. image size)."),
     EO_OP_FUNC(efl_file_async_get, NULL, "Retrieves the asynchronous open flag, which will be true only if enabled and supported by the object."),
     EO_OP_FUNC(efl_file_save, NULL, "Save the given image object's contents to an (image) file."),
     EO_OP_FUNC(efl_file_eject, NULL, "Eject the represented object."),
     EO_OP_FUNC(efl_file_async_wait, NULL, "Block and wait until all asynchronous operations are completed. Unless the async flag was set on this object, this method has no effect."),
     EO_OP_SENTINEL
};

static const Eo_Event_Description *_efl_file_event_desc[] = {
     EFL_FILE_EVENT_ASYNC_OPENED,
     EFL_FILE_EVENT_ASYNC_ERROR,
     NULL
};

static const Eo_Class_Description _efl_file_class_desc = {
     EO_VERSION,
     "Efl_File",
     EO_CLASS_TYPE_INTERFACE,
     EO_CLASS_DESCRIPTION_OPS(_efl_file_op_desc),
     _efl_file_event_desc,
     0,
     NULL,
     NULL
};

EO_DEFINE_CLASS(efl_file_interface_get, &_efl_file_class_desc, NULL, NULL);